searchNodes=[{"doc":"HTTP/2 client for Elixir.Written to manage HTTP/2 connections for pigeon.Requires Elixir 1.4/OTP 19.2 or later.Usage{:ok, pid} = Kadabra.open(&quot;https://http2.golang.org&quot;) Kadabra.get(pid, &quot;/&quot;) receive do {:end_stream, %Kadabra.Stream.Response{} = stream} -&gt; IO.inspect stream after 5_000 -&gt; IO.puts &quot;Connection timed out.&quot; end %Kadabra.Stream.Response{ body: &quot;&lt;html&gt;\\\\n&lt;body&gt;\\\\n&lt;h1&gt;Go + HTTP/2&lt;/h1&gt;\\\\n\\\\n&lt;p&gt;Welcome to...&quot; headers: [ {&quot;:status&quot;, &quot;200&quot;}, {&quot;content-type&quot;, &quot;text/html; charset=utf-8&quot;}, {&quot;content-length&quot;, &quot;1708&quot;}, {&quot;date&quot;, &quot;Sun, 16 Oct 2016 21:20:47 GMT&quot;} ], id: 1, status: 200 }Making Requests Manually{:ok, pid} = Kadabra.open(&quot;https://http2.golang.org&quot;) path = &quot;/ECHO&quot; # Route echoes PUT body in uppercase body = &quot;sample echo request&quot; headers = [ {&quot;:method&quot;, &quot;PUT&quot;}, {&quot;:path&quot;, path}, ] Kadabra.request(pid, headers, body) receive do {:end_stream, %Kadabra.Stream.Response{} = stream} -&gt; IO.inspect stream after 5_000 -&gt; IO.puts &quot;Connection timed out.&quot; end %Kadabra.Stream.Response{ body: &quot;SAMPLE ECHO REQUEST&quot;, headers: [ {&quot;:status&quot;, &quot;200&quot;}, {&quot;content-type&quot;, &quot;text/plain; charset=utf-8&quot;}, {&quot;date&quot;, &quot;Sun, 16 Oct 2016 21:28:15 GMT&quot;} ], id: 1, status: 200 }","ref":"Kadabra.html","title":"Kadabra","type":"module"},{"doc":"Closes an existing connection.Examplesiex&gt; {:ok, pid} = Kadabra.open(&quot;https://http2.golang.org&quot;) iex&gt; Kadabra.close(pid) iex&gt; receive do ...&gt; {:closed, _pid} -&gt; &quot;connection closed!&quot; ...&gt; end &quot;connection closed!&quot;","ref":"Kadabra.html#close/1","title":"Kadabra.close/1","type":"function"},{"doc":"Makes a DELETE request.Examplesiex&gt; {:ok, pid} = Kadabra.open(&#39;https://http2.golang.org&#39;) iex&gt; Kadabra.delete(pid, &quot;/&quot;) :ok iex&gt; stream = receive do ...&gt; {:end_stream, stream} -&gt; stream ...&gt; end iex&gt; stream.status 200","ref":"Kadabra.html#delete/3","title":"Kadabra.delete/3","type":"function"},{"doc":"Makes a GET request.Examplesiex&gt; {:ok, pid} = Kadabra.open(&#39;https://http2.golang.org&#39;) iex&gt; Kadabra.head(pid, &quot;/reqinfo&quot;) :ok iex&gt; response = receive do ...&gt; {:end_stream, response} -&gt; response ...&gt; end iex&gt; {response.id, response.status, response.body} {1, 200, &quot;&quot;}","ref":"Kadabra.html#get/3","title":"Kadabra.get/3","type":"function"},{"doc":"Makes a HEAD request.Examplesiex&gt; {:ok, pid} = Kadabra.open(&#39;https://http2.golang.org&#39;) iex&gt; Kadabra.head(pid, &quot;/&quot;) :ok iex&gt; response = receive do ...&gt; {:end_stream, response} -&gt; response ...&gt; end iex&gt; {response.id, response.status, response.body} {1, 200, &quot;&quot;}","ref":"Kadabra.html#head/3","title":"Kadabra.head/3","type":"function"},{"doc":"Opens a new connection.Examplesiex&gt; {:ok, pid} = Kadabra.open(&quot;http://http2.golang.org&quot;) iex&gt; is_pid(pid) true iex&gt; {:ok, pid} = Kadabra.open(&quot;https://http2.golang.org&quot;) iex&gt; is_pid(pid) true","ref":"Kadabra.html#open/2","title":"Kadabra.open/2","type":"function"},{"doc":"Pings an existing connection.Examplesiex&gt; {:ok, pid} = Kadabra.open(&#39;https://http2.golang.org&#39;) iex&gt; Kadabra.ping(pid) iex&gt; receive do ...&gt; {:pong, _pid} -&gt; &quot;got pong!&quot; ...&gt; end &quot;got pong!&quot;","ref":"Kadabra.html#ping/1","title":"Kadabra.ping/1","type":"function"},{"doc":"Makes a POST request.Examplesiex&gt; {:ok, pid} = Kadabra.open(&#39;https://http2.golang.org&#39;) iex&gt; Kadabra.post(pid, &quot;/&quot;, body: &quot;test=123&quot;) :ok iex&gt; response = receive do ...&gt; {:end_stream, response} -&gt; response ...&gt; end iex&gt; {response.id, response.status} {1, 200}","ref":"Kadabra.html#post/3","title":"Kadabra.post/3","type":"function"},{"doc":"Makes a PUT request.Examplesiex&gt; {:ok, pid} = Kadabra.open(&#39;https://http2.golang.org&#39;) iex&gt; Kadabra.put(pid, &quot;/crc32&quot;, body: &quot;test&quot;) :ok iex&gt; stream = receive do ...&gt; {:end_stream, stream} -&gt; stream ...&gt; end iex&gt; stream.status 200 iex&gt; stream.body &quot;bytes=4, CRC32=d87f7e0c&quot;","ref":"Kadabra.html#put/3","title":"Kadabra.put/3","type":"function"},{"doc":"Makes a request with given headers and optional body.Examplesiex&gt; {:ok, pid} = Kadabra.open(&#39;https://http2.golang.org&#39;) iex&gt; path = &quot;/ECHO&quot; # Route echoes PUT body in uppercase iex&gt; body = &quot;sample echo request&quot; iex&gt; headers = [ ...&gt; {&quot;:method&quot;, &quot;PUT&quot;}, ...&gt; {&quot;:path&quot;, path}, ...&gt; ] iex&gt; Kadabra.request(pid, headers: headers, body: body) iex&gt; response = receive do ...&gt; {:end_stream, %Kadabra.Stream.Response{} = response} -&gt; response ...&gt; after 5_000 -&gt; :timed_out ...&gt; end iex&gt; {response.id, response.status, response.body} {1, 200, &quot;SAMPLE ECHO REQUEST&quot;}","ref":"Kadabra.html#request/2","title":"Kadabra.request/2","type":"function"},{"doc":"Options for connections.:ssl - Specify custom options for :ssl.connect/3 when used with :https scheme.:tcp - Specify custom options for :gen_tcp.connect/3 when used with :http scheme.","ref":"Kadabra.html#t:conn_opts/0","title":"Kadabra.conn_opts/0","type":"type"},{"doc":"Options for making requests.:headers - (Required) Headers for request.:body - (Optional) Used for requests that can have a body, such as POST.:on_response - (Optional) Async callback for handling stream response.","ref":"Kadabra.html#t:request_opts/0","title":"Kadabra.request_opts/0","type":"type"},{"doc":"","ref":"Kadabra.html#t:uri/0","title":"Kadabra.uri/0","type":"type"},{"doc":"Struct to encapsulate Kadabra requests.Useful when queueing multiple requests at once through Kadabra.request/2","ref":"Kadabra.Request.html","title":"Kadabra.Request","type":"module"},{"doc":"Returns a new Kadabra.Request struct from given opts.Examplesiex&gt; Kadabra.Request.new([ ...&gt; headers: [{&quot;:method&quot;, &quot;GET&quot;}, {&quot;path&quot;, &quot;/&quot;}], ...&gt; body: &quot;&quot;, ...&gt; on_response: &amp;IO.inspect/1 ...&gt; ]) %Kadabra.Request{ headers: [{&quot;:method&quot;, &quot;GET&quot;}, {&quot;path&quot;, &quot;/&quot;}], body: &quot;&quot;, on_response: &amp;IO.inspect/1 }","ref":"Kadabra.Request.html#new/1","title":"Kadabra.Request.new/1","type":"function"},{"doc":"","ref":"Kadabra.Request.html#t:t/0","title":"Kadabra.Request.t/0","type":"type"},{"doc":"Response struct returned from open streams.If received as a push promise, :status and :body will most likely be empty.Sample response for a PUT request%Kadabra.Stream.Response{ body: &quot;SAMPLE ECHO REQUEST&quot;, headers: [ {&quot;:status&quot;, &quot;200&quot;}, {&quot;content-type&quot;, &quot;text/plain; charset=utf-8&quot;}, {&quot;date&quot;, &quot;Sun, 16 Oct 2016 21:28:15 GMT&quot;} ], id: 1, status: 200 }","ref":"Kadabra.Stream.Response.html","title":"Kadabra.Stream.Response","type":"module"},{"doc":"Fetches header with given name.Examplesiex&gt; stream = %Kadabra.Stream.Response{headers: [{&quot;:status&quot;, &quot;200&quot;}]} iex&gt; Kadabra.Stream.Response.get_header(stream.headers, &quot;:status&quot;) {&quot;:status&quot;, &quot;200&quot;}","ref":"Kadabra.Stream.Response.html#get_header/2","title":"Kadabra.Stream.Response.get_header/2","type":"function"},{"doc":"","ref":"Kadabra.Stream.Response.html#t:t/0","title":"Kadabra.Stream.Response.t/0","type":"type"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"ChangedMinimum Elixir version bumped to 1.6.FixedRemoved Elixir 1.11 compile warnings.","ref":"changelog.html#v0-5-0","title":"Changelog - v0.5.0","type":"extras"},{"doc":"Removed some compile warnings.","ref":"changelog.html#v0-4-5","title":"Changelog - v0.4.5","type":"extras"},{"doc":"Fixed ArithmeticError when calculating how many streams to request on infinite stream sets.","ref":"changelog.html#v0-4-4","title":"Changelog - v0.4.4","type":"extras"},{"doc":"Fixed supervisor crash report during normal connection shutdown.Removed GenStage dependency.GOAWAY error logger messages now disabled by default. Re-enable with config :kadabra, debug_log?: true.","ref":"changelog.html#v0-4-3","title":"Changelog - v0.4.3","type":"extras"},{"doc":"Fixed {:closed, pid} task race condition during connection cleanup.Everything is supervised under Kadabra.Application again, instead of handling supervision yourself.","ref":"changelog.html#v0-4-2","title":"Changelog - v0.4.2","type":"extras"},{"doc":"Send exactly number of allowed bytes on initial connection WINDOW_UPDATE.Default settings use maximum values for MAX_FRAME_SIZE and INITIAL_WINDOW_SIZE.Incoming PING and WINDOW_UPDATE frames are now validated, closing the connection if an error is encountered.Fixed: can no longer accidentally send 0-size WINDOW_UPDATE frames.Fixed: don't send WINDOW_UPDATE frames larger than remote server's available connection flow window.","ref":"changelog.html#v0-4-1","title":"Changelog - v0.4.1","type":"extras"},{"doc":"Support for http URIs.Requests are now buffered with GenStage.Added Kadabra.head/2 and Kadabra.delete/2.Kadabra.open/3 replaced with Kadabra.open/2.Scheme, host and port are now automatically parsed from the URI string. See the README for examples.Socket options passed as :tcp/:ssl, respectively.Removed :reconnect functionality.","ref":"changelog.html#v0-4-0","title":"Changelog - v0.4.0","type":"extras"},{"doc":"Fixed: Streams properly killed if hpack table crashes.Removed unused Scribe dependency.","ref":"changelog.html#v0-3-8","title":"Changelog - v0.3.8","type":"extras"},{"doc":"Fixed: noproc crash caused by race condition on recv GOAWAY.","ref":"changelog.html#v0-3-7","title":"Changelog - v0.3.7","type":"extras"},{"doc":"Fixed: ES flag properly set on certain HEADERS frames.","ref":"changelog.html#v0-3-6","title":"Changelog - v0.3.6","type":"extras"},{"doc":"Fixed: Memory leak on connection crashes.New supervision structure. Kadabra.open/2 now returns a supervisor pid, but the API for making requests remains unchanged.","ref":"changelog.html#v0-3-5","title":"Changelog - v0.3.5","type":"extras"},{"doc":"Fixed: Connections properly respect settings updates.","ref":"changelog.html#v0-3-4","title":"Changelog - v0.3.4","type":"extras"},{"doc":"Fixed: Hpack memory leak on connection close.","ref":"changelog.html#v0-3-3","title":"Changelog - v0.3.3","type":"extras"},{"doc":"Fixed: Connection settings defaults are now actually default.","ref":"changelog.html#v0-3-2","title":"Changelog - v0.3.2","type":"extras"},{"doc":"Fixed: Sending payloads larger than the stream window.","ref":"changelog.html#v0-3-1","title":"Changelog - v0.3.1","type":"extras"},{"doc":"Minimum requirements are now Elixir 1.4/OTP 19.Performance improvements for individual streams.Fixed: multiple connections now supported per host.Request responses now return with new %Stream.Response{} struct.Push promises can be intercepted with {:push_promise, %Stream.Response{}} messages.","ref":"changelog.html#v0-3-0","title":"Changelog - v0.3.0","type":"extras"},{"doc":"Connection now respects max_concurrent_streams.Fixed: proper WINDOW_UPDATE responses on received DATA frames.","ref":"changelog.html#v0-2-2","title":"Changelog - v0.2.2","type":"extras"},{"doc":"Fixed: calling Kadabra.open/3 with reconnect: false to disable automatic reconnect on socket close.","ref":"changelog.html#v0-2-1","title":"Changelog - v0.2.1","type":"extras"}]